/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fck_2.js
 * 	This is the second part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:49
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

FCK.ExecuteNamedCommand = function( commandName, commandParameter )
{
	this.EditorDocument.execCommand( commandName, false, commandParameter ) ; 
	this.Events.FireEvent( 'OnSelectionChange' ) ;
}

FCK.GetNamedCommandState = function( commandName )
{
	try
	{
		if ( !FCK.EditorDocument.queryCommandEnabled( commandName ) )
			return FCK_TRISTATE_DISABLED ;
		else
			return FCK.EditorDocument.queryCommandState( commandName ) ? FCK_TRISTATE_ON : FCK_TRISTATE_OFF ;
	}
	catch ( e )
	{
		return FCK_TRISTATE_OFF ;
	}
}

FCK.GetNamedCommandValue = function( commandName )
{
	var sValue = '' ;
	var eState = FCK.GetNamedCommandState( commandName ) ;
	
	if ( eState == FCK_TRISTATE_DISABLED ) 
		return null ;
	
	try
	{
		sValue = this.EditorDocument.queryCommandValue( commandName ) ;
	}
	catch(e) {}
	
	return sValue ? sValue : '' ;
}

FCK.CreateLink = function( url )
{	
	if ( url.length == 0 )
		this.ExecuteNamedCommand( 'Unlink' ) ;
	else
	{
		this.ExecuteNamedCommand( 'CreateLink', "javascript:void(0);/*fckeditortemplink*/" ) ;

		var oLinks = this.EditorDocument.links ;
		for ( i = 0 ; i < oLinks.length ; i++ )
		{
			if ( oLinks[i].href == "javascript:void(0);/*fckeditortemplink*/" )
			{
				oLinks[i].href = url ;
				return oLinks[i] ;
			}
		}
	}
}

FCK.CleanAndPaste = function( html )
{
	// Remove all SPAN tags
	html = html.replace(/<\/?SPAN[^>]*>/gi, "" );
	// Remove Class attributes
	html = html.replace(/<(\w[^>]*) class=([^ |>]*)([^>]*)/gi, "<$1$3") ;
	// Remove Style attributes
	html = html.replace(/<(\w[^>]*) style="([^"]*)"([^>]*)/gi, "<$1$3") ;
	// Remove Lang attributes
	html = html.replace(/<(\w[^>]*) lang=([^ |>]*)([^>]*)/gi, "<$1$3") ;
	// Remove XML elements and declarations
	html = html.replace(/<\\?\?xml[^>]*>/gi, "") ;
	// Remove Tags with XML namespace declarations: <o:p></o:p>
	html = html.replace(/<\/?\w+:[^>]*>/gi, "") ;
	// Replace the &nbsp;
	html = html.replace(/&nbsp;/, " " );
	// Transform <P> to <DIV>
	var re = new RegExp("(<P)([^>]*>.*?)(<\/P>)","gi") ;	// Different because of a IE 5.0 error
	html = html.replace( re, "<div$2</div>" ) ;
	
	this.InsertHtml( html ) ;
}

FCK.Preview = function()
{
	var oWindow = window.open( '', null, 'toolbar=yes,location=yes,status=yes,menubar=yes,scrollbars=yes,resizable=yes' ) ;
	oWindow.document.write( FCK.GetHTML() );
	oWindow.document.close();
	
	// TODO: The CSS of the editor area must be configurable.
	// oWindow.document.createStyleSheet( config.EditorAreaCSS );
}

FCK.SwitchEditMode = function()
{
	// Check if the actual mode is WYSIWYG.
	var bWYSIWYG = ( FCK.EditMode == FCK_EDITMODE_WYSIWYG ) ;
	
	// Display/Hide the TRs.
	document.getElementById('eWysiwyg').style.display	= bWYSIWYG ? "none" : "" ;
	document.getElementById('eSource').style.display	= bWYSIWYG ? "" : "none" ;

	// Update the HTML in the view output to show.
	if ( bWYSIWYG )
		document.getElementById('eSourceField').value = ( FCKConfig.EnableXHTML && FCKConfig.EnableSourceXHTML ? FCK.GetXHTML() : FCK.GetHTML() ) ;
	else
		FCK.SetHTML( FCK.GetHTML(), true ) ;

	// Updates the actual mode status.
	FCK.EditMode = bWYSIWYG ? FCK_EDITMODE_SOURCE : FCK_EDITMODE_WYSIWYG ;
	
	// Set the Focus.
	FCK.Focus() ;
	
	// Update the toolbar.
	FCKToolbarSet.RefreshItemsState() ;
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fck_2_gecko.js
 * 	This is the second part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 	(Gecko specific implementations)
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:49
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// GetNamedCommandState overload for Gecko.
FCK._BaseGetNamedCommandState = FCK.GetNamedCommandState ;
FCK.GetNamedCommandState = function( commandName )
{
	switch ( commandName )
	{
		case 'Unlink' :
			return FCKSelection.HasAncestorNode('A') ? FCK_TRISTATE_OFF : FCK_TRISTATE_DISABLED ;
		default :
			return FCK._BaseGetNamedCommandState( commandName ) ;
	}
}

// ExecuteNamedCommand overload for Gecko.
FCK._BaseExecuteNamedCommand = FCK.ExecuteNamedCommand ;
FCK.ExecuteNamedCommand = function( commandName, commandParameter )
{
	switch ( commandName )
	{
		case 'Print' :
			FCK.EditorWindow.print();
		default :
			FCK._BaseExecuteNamedCommand( commandName, commandParameter ) ;
	}
}

FCK.Focus = function()
{
	this.EditorWindow.focus() ;
}

FCK.AttachToOnSelectionChange = function( functionPointer )
{
	this.Events.AttachEvent( 'OnSelectionChange', functionPointer ) ;
}

FCK.Paste = function()
{
	FCKDebug.Output( 'FCK.Paste' ) ;

	if ( FCKConfig.ForcePasteAsPlainText )
	{
		FCK.PasteAsPlainText() ;	
		return false ;
	}
	else if ( FCKConfig.AutoDetectPasteFromWord && FCKBrowserInfo.IsIE55OrMore )
	{
		var sHTML = FCK.GetClipboardHTML() ;
		var re = /<\w[^>]* class="?MsoNormal"?/gi ;
		if ( re.test( sHTML ) )
		{
			if ( confirm( FCKLang["PasteWordConfirm"] ) )
			{
				FCK.CleanAndPaste( sHTML ) ;
				return false ;
			}
		}
	}
	else
		return true ;
}

//**
// FCK.InsertHtml: Inserts HTML at the current cursor location. Deletes the
// selected content if any.
FCK.InsertHtml = function( html )
{
	// Delete the actual selection.
	var oSel = FCKSelection.Delete() ;
	
//	var oContainer	= oSel.getRangeAt(0).startContainer ;
//	var iOffSet		= oSel.getRangeAt(0).startOffset ;
	
	// Get the first available range.
	var oRange = oSel.getRangeAt(0) ;
	
//	var oRange = this.EditorDocument.createRange() ;
//	oRange.setStart( oContainer, iOffSet ) ;
//	oRange.setEnd( oContainer, iOffSet ) ;
	
	// Create a fragment with the input HTML.
	var oFragment = oRange.createContextualFragment( html ) ;
	
	// Get the last available node.
	var oLastNode = oFragment.lastChild ;

	// Insert the fragment in the range.
	oRange.insertNode(oFragment) ;
	
	// Set the cursor after the inserted fragment.
	oRange.setEndAfter( oLastNode ) ;
	oRange.setStartAfter( oLastNode ) ;
	
	oSel.removeAllRanges() ;
	oSel = FCK.EditorWindow.getSelection() ;
	oSel.addRange( oRange ) ;
		
	this.Focus() ;
}

FCK.InsertElement = function( element )
{
	// Deletes the actual selection.
	var oSel = FCKSelection.Delete() ;
	
	// Gets the first available range.
	var oRange = oSel.getRangeAt(0) ;
	
	// Inserts the element in the range.
	oRange.insertNode( element ) ;
	
	// Set the cursor after the inserted fragment.
	oRange.setEndAfter( element ) ;
	oRange.setStartAfter( element ) ;

	this.Focus() ;
}

FCK.PasteAsPlainText = function()
{
/*
	var sText = FCKTools.HTMLEncode( clipboardData.getData("Text") ) ;

	FCKDebug.Output( 'FCK.PasteAsPlainText: ' + sText ) ;

	sText = sText.replace( /\n/g, '<BR>' ) ;
	this.InsertHtml( sText ) ;	
*/
}

FCK.GetClipboardHTML = function()
{
	return '' ;
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckselection.js
 * 	Active selection functions.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:50
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKSelection = new Object() ;

FCK.Selection = FCKSelection ;/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckselection_gecko.js
 * 	Active selection functions. (Gecko specific implementation)
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:50
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// Retrieves the selected element (if any), just in the case that a single 
// element is selected.
FCKSelection.GetSelectedElement = function()
{
	var oSel = FCK.EditorWindow.getSelection() ;
	if ( oSel.rangeCount == 1 )
	{
		var oRange = oSel.getRangeAt(0) ;
		if ( oRange.startContainer == oRange.endContainer && (oRange.endOffset - oRange.startOffset) == 1 )
			return oSel.anchorNode.childNodes[ oSel.anchorOffset ] ;
	}
}

FCKSelection.MoveToNode = function( node )
{
	var oSel = FCK.EditorWindow.getSelection() ;

	for ( i = oSel.rangeCount - 1 ; i >= 0 ; i-- )
	{
		if ( i == 0 )
		{
			oSel.getRangeAt(i).selectNodeContents( node ) ;
		}
		else
		{
			oSel.removeRange( oSel.getRangeAt(i) ) ;
		}
	}
}

FCKSelection.HasAncestorNode = function( nodeTagName )
{
	var oContainer = this.GetSelectedElement() ;
	if ( ! oContainer && FCK.EditorWindow )
	{
		try		{ oContainer = FCK.EditorWindow.getSelection().getRangeAt(0).startContainer ; }
		catch(e){}
	}
	
	while ( oContainer )
	{
		if ( oContainer.tagName == nodeTagName ) return true ;
		oContainer = oContainer.parentNode ;
	}

	return false ;
}

FCKSelection.MoveToAncestorNode = function( nodeTagName )
{
	var oNode ;
	
	var oContainer = this.GetSelectedElement() ;
	if ( ! oContainer )
	{
		oContainer = FCK.EditorWindow.getSelection().getRangeAt(0).startContainer ;
	}
	
	while ( oContainer )
	{
		if ( oContainer.tagName == nodeTagName ) return oContainer ;
		oContainer = oContainer.parentNode ;
	}
}

FCKSelection.Delete = function()
{
	// Gets the actual selection.
	var oSel = FCK.EditorWindow.getSelection() ;

	// Deletes the actual selection contents.
	for ( var i = 0 ; i < oSel.rangeCount ; i++ )
	{
		oSel.getRangeAt(i).deleteContents() ;
	}
	
	return oSel ;
}/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fcknamedcommand.js
 * 	FCKNamedCommand Class: represents a internal browser command.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKNamedCommand = function( commandName )
{
	this.Name = commandName ;
}

FCKNamedCommand.prototype.Execute = function()
{
	FCK.ExecuteNamedCommand( this.Name ) ;
}

FCKNamedCommand.prototype.GetState = function()
{
	return FCK.GetNamedCommandState( this.Name ) ;
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fck_othercommands.js
 * 	Definition of other commands that are not available internaly in the
 * 	browser (see FCKNamedCommand).
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// ### General Dialog Box Commands.
var FCKDialogCommand = function( name, title, url, width, height, getStateFunction, getStateParam )
{
	this.Name	= name ;
	this.Title	= title ;
	this.Url	= url ;
	this.Width	= width ;
	this.Height	= height ;
	
	this.GetStateFunction	= getStateFunction ;
	this.GetStateParam		= getStateParam ;
}

FCKDialogCommand.prototype.Execute = function()
{
	FCKDialog.OpenDialog( 'FCKDialog_' + this.Name , this.Title, this.Url, this.Width, this.Height ) ;
}

FCKDialogCommand.prototype.GetState = function()
{
	if ( this.GetStateFunction )
	{
		return this.GetStateFunction( this.GetStateParam ) ;
	}
	else
	{
		return FCK_TRISTATE_OFF ;
	}
}

// Generic Undefined command (usually used when a command is under development).
var FCKUndefinedCommand = function()
{
	this.Name = 'Undefined' ;
}

FCKUndefinedCommand.prototype.Execute = function()
{
	alert( 'Undefined command' ) ;
} 

FCKUndefinedCommand.prototype.GetState = function()
{
	return FCK_TRISTATE_OFF ;
}

// ### FontName
var FCKFontNameCommand = function() 
{
	this.Name = 'FontName' ;
}

FCKFontNameCommand.prototype.Execute = function( fontName )
{
	if (fontName == null || fontName == "")
	{
		// TODO: Remove font name attribute.
	}
	else
	{
		FCK.ExecuteNamedCommand( 'FontName', fontName ) ;
	}
}

FCKFontNameCommand.prototype.GetState = function()
{
	return FCK.GetNamedCommandValue( 'FontName' ) ;
}

// ### FontSize
var FCKFontSizeCommand = function() 
{
	this.Name = 'FontSize' ;
}

FCKFontSizeCommand.prototype.Execute = function( fontSize )
{
	if ( typeof( fontSize ) == 'string' ) fontSize = parseInt(fontSize) ;
	
	if ( fontSize == null || fontSize == '' )
	{
		// TODO: Remove font size attribute (Now it works with size 3. Will it work forever?)
		FCK.ExecuteNamedCommand( 'FontSize', 3 ) ;
	}
	else
	{
		FCK.ExecuteNamedCommand( 'FontSize', fontSize ) ;
	}
}

FCKFontSizeCommand.prototype.GetState = function()
{
	return FCK.GetNamedCommandValue( 'FontSize' ) ;
}

// ### FormatBlock
var FCKFormatBlockCommand = function() 
{
	this.Name = 'FormatBlock' ;
}

FCKFormatBlockCommand.prototype.Execute = function( formatName )
{
	if ( formatName == null || formatName == '' )
	{
		FCK.ExecuteNamedCommand( 'FormatBlock', '<P>' ) ;
	}
	else
	{
		FCK.ExecuteNamedCommand( 'FormatBlock', formatName ) ;
	}
}

FCKFormatBlockCommand.prototype.GetState = function()
{
	return FCK.GetNamedCommandValue( 'FormatBlock' ) ;
}

// ### Preview
var FCKPreviewCommand = function() 
{
	this.Name = 'Preview' ;
}

FCKPreviewCommand.prototype.Execute = function()
{
     FCK.Preview() ;
}

FCKPreviewCommand.prototype.GetState = function()
{
	return FCK_TRISTATE_OFF ;
}

// ### Save
var FCKSaveCommand = function() 
{
	this.Name = 'Save' ;
}

FCKSaveCommand.prototype.Execute = function()
{
	// Get the linked field form.
	var oForm = FCK.LinkedField.form ;
	
	// Submit the form.
	oForm.submit() ;
}

FCKSaveCommand.prototype.GetState = function()
{
	return FCK_TRISTATE_OFF ;
}

// ### NewPage
var FCKNewPageCommand = function() 
{
	this.Name = 'NewPage' ;
}

FCKNewPageCommand.prototype.Execute = function()
{
	FCK.SetHTML( '' ) ;
}

FCKNewPageCommand.prototype.GetState = function()
{
	return FCK_TRISTATE_OFF ;
}

// ### Source button
var FCKSourceCommand = function()
{
	this.Name = "Source" ;
}

FCKSourceCommand.prototype.Execute = function()
{
     FCK.SwitchEditMode() ;
}

FCKSourceCommand.prototype.GetState = function()
{
	return ( FCK.EditMode == FCK_EDITMODE_WYSIWYG ? FCK_TRISTATE_OFF : FCK_TRISTATE_ON ) ;
}/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckcommands.js
 * 	Define all commands available in the editor.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:49
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKCommands = new Object() ;

/*
Instead of adding a line like this for every named command:
FCKCommands['Bold'] = new FCKNamedCommand( 'Bold' ) ;
... an Array was created to simplify the code (and reduce its size).
*/
var sNamedCommands = [ 
	'Cut','Copy','Paste','Print','Find','SelectAll','RemoveFormat','Unlink','Undo','Redo',
	'Bold','Italic','Underline','StrikeThrough','Subscript','Superscript',
	'JustifyLeft','JustifyCenter','JustifyRight','JustifyFull','Outdent','Indent',
	'InsertOrderedList','InsertUnorderedList','InsertHorizontalRule'] ;

// Loops throw all named items.
for ( i = 0 ; i < sNamedCommands.length ; i++ )
{
	FCKCommands[ sNamedCommands[i] ] = new FCKNamedCommand( sNamedCommands[i] ) ;
}

//### Other Commands.
FCKCommands['Link']			= new FCKDialogCommand( 'Link'			, FCKLang.DlgLnkWindowTitle, 'dialog/fck_link.html'	, 400, 330, FCK.GetNamedCommandState, 'CreateLink' ) ;
FCKCommands['About']		= new FCKDialogCommand( 'About'			, FCKLang.About, 'dialog/fck_about.html'	, 400, 330 ) ;

FCKCommands['Image']		= new FCKDialogCommand( 'Image'			, 'Image Properties', 'dialog/fck_image.html'		, 450, 400, FCK.GetNamedCommandState, 'InsertImage' ) ;
FCKCommands['Table']		= new FCKDialogCommand( 'Table'			, 'Table Properties', 'dialog/fck_table.html'		, 400, 250 ) ;
FCKCommands['TableProp']	= new FCKDialogCommand( 'Table'			, 'Table Properties', 'dialog/fck_table.html?Parent', 400, 250 ) ;
FCKCommands['SpecialChar']	= new FCKDialogCommand( 'SpecialChar'	, 'Select Character', 'dialog/fck_specialchar.html'	, 400, 300, FCK.GetNamedCommandState, 'InsertImage' ) ;
FCKCommands['Smiley']		= new FCKDialogCommand( 'Smiley'		, FCKLang.DlgSmileyTitle, 'dialog/fck_smiley.html'	, FCKConfig.SmileyWindowWidth, FCKConfig.SmileyWindowHeight, FCK.GetNamedCommandState, 'InsertImage' ) ;

FCKCommands['FontName']		= new FCKFontNameCommand() ;
FCKCommands['FontSize']		= new FCKFontSizeCommand() ;
FCKCommands['FontFormat']	= new FCKFormatBlockCommand() ;

FCKCommands['Source']		= new FCKSourceCommand() ;
FCKCommands['Preview']		= new FCKPreviewCommand() ;
FCKCommands['Save']			= new FCKSaveCommand() ;
FCKCommands['NewPage']		= new FCKNewPageCommand() ;

// Generic Undefined command (usually used when a command is under development).
FCKCommands['Undefined']	= new FCKUndefinedCommand() ;

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fcktoolbarbutton.js
 * 	FCKToolbarButton Class: represents a button in the toolbar.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKToolbarButton = function( commandName, label, tooltip, style, sourceView )
{
	this.Command	= FCKCommands[ commandName ] ;
	this.Label		= label ? GetText(label) : GetText(commandName) ;
	this.Tooltip	= tooltip ? GetText(tooltip) : this.Label;
	this.Style		= style ? style : FCK_TOOLBARITEM_ONLYICON ;
	this.SourceView	= sourceView ? true : false ;
	this.State		= FCK_UNKNOWN ;
}

FCKToolbarButton.prototype.CreateInstance = function( parentToolbar )
{
/*
	<td title="Bold" class="TB_Button_Off" unselectable="on" onmouseover="Button_OnMouseOver(this);" onmouseout="Button_OnMouseOut(this);">
		<table class="TB_ButtonType_Icon" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="TB_Icon"><img src="icons/button.redo.gif" width="21" height="21" style="VISIBILITY: hidden" onload="this.style.visibility = '';"></td>
				<td class="TB_Text" unselectable="on">Redo</td>
			</tr>
		</table>
	</td>
*/	
	this.DOMDiv = document.createElement( 'div' ) ;
	this.DOMDiv.className		= 'TB_Button_Off' ;

	this.DOMDiv.FCKToolbarButton	= this ;
	
	this.DOMDiv.onmouseover = function()
	{
		if ( this.FCKToolbarButton.State != FCK_TRISTATE_DISABLED )
		{
			this.className = 'TB_Button_On' ;
		}
	}
	
	this.DOMDiv.onmouseout	= function()
	{
		if ( this.FCKToolbarButton.State != FCK_TRISTATE_DISABLED &&  this.FCKToolbarButton.State != FCK_TRISTATE_ON )
		{
			this.className = 'TB_Button_Off' ;
		}
	}
	
	this.DOMDiv.onclick = function()
	{
		if ( this.FCKToolbarButton.State != FCK_TRISTATE_DISABLED )
			this.FCKToolbarButton.Command.Execute() ;
		return false ;
	}

	// Gets the correct CSS class to use for the specified style (param).
	var sClass ;
	switch ( this.Style )
	{
		case FCK_TOOLBARITEM_ONLYICON :
			sClass = 'TB_ButtonType_Icon' ;
			break ;
		case FCK_TOOLBARITEM_ONLYTEXT :
			sClass = 'TB_ButtonType_Text' ;
			break ;
		case FCK_TOOLBARITEM_ICONTEXT :
			sClass = '' ;
			break ;
	}

	this.DOMDiv.innerHTML = 
		'<table title="' + this.Tooltip + '" class="' + sClass + '" cellspacing="0" cellpadding="0" border="0" unselectable="on">' +
			'<tr>' +
				'<td class="TB_Icon" unselectable="on"><img src="' + FCKConfig.SkinPath + 'toolbar/button.' + this.Command.Name.toLowerCase() + FCKConfig.SkinType + '" width="' + FCKConfig.SkinSize + '" height="' + FCKConfig.SkinSize + '" style="VISIBILITY: hidden" onload="this.style.visibility = \'\';" unselectable="on"></td>' +
				'<td class="TB_Text" unselectable="on">' + this.Label + '</td>' +
			'</tr>' +
		'</table>' ;
	

	var oCell = parentToolbar.DOMRow.insertCell(-1) ;
	oCell.appendChild( this.DOMDiv ) ;
	
	this.RefreshState() ;
}

FCKToolbarButton.prototype.RefreshState = function()
{
	// Gets the actual state.
	var eState ;
	
	if ( FCK.EditMode == FCK_EDITMODE_SOURCE && ! this.SourceView )
		eState = FCK_TRISTATE_DISABLED ;
	else
		eState = this.Command.GetState() ;
	
	// If there are no state changes than do nothing and return.
	if ( eState == this.State ) return ;
	
	// Sets the actual state.
	this.State = eState ;
	
	switch ( this.State )
	{
		case FCK_TRISTATE_ON :
			this.DOMDiv.className = 'TB_Button_On' ;
			break ;
		case FCK_TRISTATE_OFF :
			this.DOMDiv.className = 'TB_Button_Off' ;
			break ;
		default :
			this.DOMDiv.className = 'TB_Button_Disabled' ;
			break ;
	}
}/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fcktoolbarcombo.js
 * 	FCKToolbarCombo Class: represents a combo in the toolbar.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:48
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKToolbarCombo = function( commandName, label, itemsValues, itemsNames, tooltip, style, firstIsBlank, itemsSeparator, sourceView )
{
	this.Command	= FCKCommands[ commandName ] ;
	
	this.Label		= label ? label : commandName ;
	this.Tooltip	= tooltip ? tooltip : ( label ? label : commandName) ;
	this.Style		= style ? style : FCK_TOOLBARITEM_ICONTEXT ;
	this.SourceView	= sourceView ? true : false ;
	this.State		= FCK_UNKNOWN ;
	
	this.ItemsValues	= itemsValues ;
	this.ItemsNames		= itemsNames ? itemsNames : itemsValues ;
	this.ItemsSeparator	= itemsSeparator ? itemsSeparator : ';' ;
	
	this.FirstIsBlank	= firstIsBlank != null ? firstIsBlank : true ;
}

FCKToolbarCombo.prototype.CreateInstance = function( parentToolbar )
{
/*
	<td class="TB_Combo_Disabled" unselectable="on">
		<table class="ButtonType_IconText" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="TB_Text" unselectable="on">Style</td>
				<td><select title="Style"><option>Style 1</option><option>Style 2</option></select></td>
			</tr>
		</table>
	</td>
*/	
	this.DOMDiv = document.createElement( 'div' ) ;
	this.DOMDiv.className		= 'TB_Combo_Off' ;

	// Gets the correct CSS class to use for the specified style (param).
	var sClass ;
	switch ( this.Style )
	{
		case FCK_TOOLBARITEM_ONLYICON :
			sClass = 'TB_ButtonType_Icon' ;
			break ;
		case FCK_TOOLBARITEM_ONLYTEXT :
			sClass = 'TB_ButtonType_Text' ;
			break ;
		case FCK_TOOLBARITEM_ICONTEXT :
			sClass = '' ;
			break ;
	}

	this.DOMDiv.innerHTML = 
		'<table class="' + sClass + '" cellspacing="0" cellpadding="0" border="0" unselectable="on">' +
			'<tr>' +
				'<td class="TB_Text" unselectable="on" nowrap>' + this.Label + '</td>' +
				'<td unselectable="on"><select title="' + this.Tooltip + '"></select></td>' +
			'</tr>' +
		'</table>' ;

	// Gets the SELECT element.
	this.SelectElement = this.DOMDiv.firstChild.firstChild.firstChild.childNodes.item(1).firstChild ;
	
	this.SelectElement.FCKToolbarCombo = this ;

	this.SelectElement.onchange = function()
	{
		this.FCKToolbarCombo.Command.Execute( this.value ) ;
		return false ;
	}

	var oCell = parentToolbar.DOMRow.insertCell(-1) ;
	oCell.appendChild( this.DOMDiv ) ;

	// Loads all combo items.
	this.RefreshItems() ;
	
	// Sets its initial state (probably disabled).
	this.RefreshState() ;
}

FCKToolbarCombo.prototype.RefreshItems = function()
{
	// Create the empty arrays of items to add (names and values)
	var aNames	= FCKTools.GetResultingArray( this.ItemsNames, this.ItemsSeparator ) ;
	var aValues	= FCKTools.GetResultingArray( this.ItemsValues, this.ItemsSeparator ) ;
	
	// Clean up the combo.
	FCKTools.RemoveAllSelectOptions( this.SelectElement ) ;
	
	// Verifies if the first item in the combo must be blank.
	if ( this.FirstIsBlank )
		FCKTools.AddSelectOption( document, this.SelectElement, '', '' ) ;
	
	// Add all items to the combo.
	for ( var i = 0 ; i < aValues.length ; i++ )
	{
		FCKTools.AddSelectOption( document, this.SelectElement, aNames[i], aValues[i] ) ;
	}
}

FCKToolbarCombo.prototype.RefreshState = function()
{
	// Gets the actual state.
	var eState ;
	
	if ( FCK.EditMode == FCK_EDITMODE_SOURCE && ! this.SourceView )
	{
		eState = FCK_TRISTATE_DISABLED ;
		
		// Cleans the actual selection.
		this.SelectElement.value = '' ;
	}
	else
	{
		var sValue = this.Command.GetState() ;

		// Sets the combo value.
		FCKTools.SelectNoCase( this.SelectElement, sValue ? sValue : '', '' ) ;

		// Gets the actual state.
		eState = sValue == null ? FCK_TRISTATE_DISABLED : FCK_TRISTATE_ON ;
	}

	// If there are no state changes then do nothing and return.
	if ( eState == this.State ) return ;
	
	// Sets the actual state.
	this.State = eState ;

	// Updates the graphical state.	
	this.DOMDiv.className		= ( eState == FCK_TRISTATE_ON ? 'TB_Combo_Off' : 'TB_Combo_Disabled' ) ;
	this.SelectElement.disabled	= ( eState == FCK_TRISTATE_DISABLED ) ;	
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fcktoolbaritems.js
 * 	Toolbar items definitions.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:50
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKToolbarItems = new Object() ;

FCKToolbarItems['Source']		= new FCKToolbarButton( 'Source', null, null, FCK_TOOLBARITEM_ICONTEXT, true ) ;
FCKToolbarItems['Save']			= new FCKToolbarButton( 'Save', null, null, null, true  ) ;
FCKToolbarItems['NewPage']		= new FCKToolbarButton( 'NewPage', null, null, null, true  ) ;
FCKToolbarItems['Preview']		= new FCKToolbarButton( 'Preview', null, null, null, true  ) ;
FCKToolbarItems['About']		= new FCKToolbarButton( 'About', FCKLang.About ) ;

FCKToolbarItems['Cut']			= new FCKToolbarButton( 'Cut', null, null, null, true ) ;
FCKToolbarItems['Copy']			= new FCKToolbarButton( 'Copy', null, null, null, true ) ;
FCKToolbarItems['Paste']		= new FCKToolbarButton( 'Paste', null, null, null, true ) ;
FCKToolbarItems['Print']		= new FCKToolbarButton( 'Print', null, null, null, true ) ;
FCKToolbarItems['Undo']			= new FCKToolbarButton( 'Undo', null, null, null, true ) ;
FCKToolbarItems['Redo']			= new FCKToolbarButton( 'Redo', null, null, null, true ) ;
FCKToolbarItems['Find']			= new FCKToolbarButton( 'Find', null, null, null, true ) ;
FCKToolbarItems['SelectAll']	= new FCKToolbarButton( 'SelectAll', null, null, null, true ) ;
FCKToolbarItems['RemoveFormat']	= new FCKToolbarButton( 'RemoveFormat', null ) ;
FCKToolbarItems['Unlink']		= new FCKToolbarButton( 'Unlink' ) ;

FCKToolbarItems['Bold']			= new FCKToolbarButton( 'Bold' ) ;
FCKToolbarItems['Italic']		= new FCKToolbarButton( 'Italic' ) ;
FCKToolbarItems['Underline']	= new FCKToolbarButton( 'Underline' ) ;
FCKToolbarItems['StrikeThrough']= new FCKToolbarButton( 'StrikeThrough' ) ;
FCKToolbarItems['Subscript']	= new FCKToolbarButton( 'Subscript' ) ;
FCKToolbarItems['Superscript']	= new FCKToolbarButton( 'Superscript' ) ;

FCKToolbarItems['OrderedList']	= new FCKToolbarButton( 'InsertOrderedList', 'Ordered List', 'Insert/Remove Ordered List' ) ;
FCKToolbarItems['UnorderedList']= new FCKToolbarButton( 'InsertUnorderedList', 'Unordered List', 'Insert/Remove Unordered List' ) ;
FCKToolbarItems['Outdent']		= new FCKToolbarButton( 'Outdent' ) ;
FCKToolbarItems['Indent']		= new FCKToolbarButton( 'Indent' ) ;

FCKToolbarItems['Link']			= new FCKToolbarButton( 'Link', 'Link', 'Create/Edit Link' ) ;
FCKToolbarItems['Unlink']		= new FCKToolbarButton( 'Unlink', 'Remove Link' ) ;

FCKToolbarItems['Image']		= new FCKToolbarButton( 'Image', 'Image', 'Insert/Edit Image' ) ;
FCKToolbarItems['Table']		= new FCKToolbarButton( 'Table', 'Table', 'Create/Edit Table' ) ;
FCKToolbarItems['SpecialChar']	= new FCKToolbarButton( 'SpecialChar', 'Special Character', 'Insert Special Character' ) ;
FCKToolbarItems['Smiley']		= new FCKToolbarButton( 'Smiley', 'Smiley', 'Insert Smiley' ) ;

FCKToolbarItems['Rule']			= new FCKToolbarButton( 'InsertHorizontalRule', 'Horizontal Rule', 'Insert Horizontal Rule' ) ;

FCKToolbarItems['JustifyLeft']	= new FCKToolbarButton( 'JustifyLeft', 'Align Left' ) ;
FCKToolbarItems['JustifyCenter']= new FCKToolbarButton( 'JustifyCenter', 'Center' ) ;
FCKToolbarItems['JustifyRight']	= new FCKToolbarButton( 'JustifyRight', 'Align Right' ) ;
FCKToolbarItems['JustifyFull']	= new FCKToolbarButton( 'JustifyFull', 'Justify' ) ;

FCKToolbarItems['FontName']		= new FCKToolbarCombo( 'FontName', FCKLang['Font'], FCKConfig.FontNames, FCKConfig.FontNames ) ;
FCKToolbarItems['FontSize']		= new FCKToolbarCombo( 'FontSize', FCKLang['FontSize'], '1;2;3;4;5;6;7', 'xx-small;x-small;small;medium;large;x-large;xx-large' ) ;
if (FCKConfig.Formats )
   FCKToolbarItems['FontFormat'] = new FCKToolbarCombo( 'FontFormat', FCKLang['FontFormat'], FCKConfig.Formats, FCKConfig.FormatsNames ) ;
else
   FCKToolbarItems['FontFormat'] = new FCKToolbarCombo( 'FontFormat', FCKLang['FontFormat'], '<p>;<div>;<h1>;<h2>', 'Normal (P);Normal (DIV);Heading 1;Heading 2' ) ;
/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fcktoolbar.js
 * 	FCKToolbar Class: represents a toolbar. A toolbar is not the complete
 * 	toolbar set visible, but just a strip on it... a group of items.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKToolbar = function()
{
	this.Items = new Array() ;
	
	this.DOMTable = document.createElement( 'table' ) ;
	this.DOMTable.className = 'TB_Toolbar' ;
	with ( this.DOMTable )
	{
		// Sets the toolbar direction. IE uses "styleFloat" and Gecko uses "cssFloat".
		style.styleFloat = style.cssFloat = FCKLang.Dir == 'rtl' ? 'right' : 'left' ;
		
		cellPadding = 0 ;
		cellSpacing = 0 ;
		border = 0 ;
	}

	this.DOMRow = this.DOMTable.insertRow(-1) ;

	var oCell = this.DOMRow.insertCell(-1) ;
	oCell.className = 'TB_Start' ;
	oCell.innerHTML = '<img src="' + FCKConfig.SkinPath + 'images/toolbar.start.gif" width="7" height="21" style="VISIBILITY: hidden" onload="this.style.visibility = \'\';" unselectable="on">' ;

	FCKToolbarSet.DOMElement.appendChild( this.DOMTable ) ;
}

FCKToolbar.prototype.AddItem = function( toolbarItem )
{
	this.Items[ this.Items.length ] = toolbarItem ;
	toolbarItem.CreateInstance( this ) ;
}

FCKToolbar.prototype.AddSeparator = function()
{
	var oCell = this.DOMRow.insertCell(-1) ;
	oCell.unselectable = 'on' ;
	oCell.innerHTML = '<img src="' + FCKConfig.SkinPath + 'images/toolbar.separator.gif" width="5" height="21" style="VISIBILITY: hidden" onload="this.style.visibility = \'\';" unselectable="on">' ;
}

FCKToolbar.prototype.AddTerminator = function()
{
	var oCell = this.DOMRow.insertCell(-1) ;
	oCell.className = 'TB_End' ;
	oCell.innerHTML = '<img src="' + FCKConfig.SkinPath + 'images/toolbar.end.gif" width="12" height="21" style="VISIBILITY: hidden" onload="this.style.visibility = \'\';" unselectable="on">' ;
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fcktoolbarset.js
 * 	Defines the FCKToolbarSet object that is used to load and draw the 
 * 	toolbar.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:50
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKToolbarSet = new Object() ;

FCKToolbarSet.Toolbars = new Array() ;

FCKToolbarSet.Expand = function()
{
	document.getElementById( 'Collapsed' ).style.display = 'none' ;
	document.getElementById( 'Expanded' ).style.display = '' ;
	
	if ( ! FCKBrowserInfo.IsIE )
	{
		// I had to use "setTimeout" because Gecko was not responding in a right
		// way when calling window.onresize() directly.
		window.setTimeout( "window.onresize()", 1 ) ;
	}
}

FCKToolbarSet.Collapse = function()
{
	document.getElementById( 'Collapsed' ).style.display = '' ;
	document.getElementById( 'Expanded' ).style.display = 'none' ;
	
	if ( ! FCKBrowserInfo.IsIE )
	{
		// I had to use "setTimeout" because Gecko was not responding in a right
		// way when calling window.onresize() directly.
		window.setTimeout( "window.onresize()", 1 ) ;
	}
}

FCKToolbarSet.Restart = function()
{
	if ( !FCKConfig.ToolbarCanCollapse || FCKConfig.ToolbarStartExpanded )
		this.Expand() ;
	else
		this.Collapse() ;
	
	document.getElementById( 'CollapseHandle' ).style.display = FCKConfig.ToolbarCanCollapse ? '' : 'none' ;
}

FCKToolbarSet.Load = function( toolbarSetName )
{
	this.DOMElement = document.getElementById( 'eToolbar' ) ;
	
	var ToolbarSet = FCKConfig.ToolbarSets[toolbarSetName] ;
	
	if (! ToolbarSet)
	{
		alert( 'Toolbar set "' + toolbarSetName + '" doesn\'t exist.' ) ;
		return ;
	}
	
	this.Toolbars = new Array() ;
	
	for ( var x = 0 ; x < ToolbarSet.length ; x++ ) 
	{
		var oToolbar = new FCKToolbar() ;
		
		for ( var j = 0 ; j < ToolbarSet[x].length ; j++ ) 
		{
			var sItem = ToolbarSet[x][j] ;
			
			if ( sItem == '-')
				oToolbar.AddSeparator() ;
			else
			{
				var oItem = FCKToolbarItems[sItem] ;
				if ( oItem )
					oToolbar.AddItem( oItem ) ;
				else
					alert( 'Unknown toolbar item name "' + sItem + "'" ) ;
			}
		}
		
		oToolbar.AddTerminator() ;
		
		this.Toolbars[ this.Toolbars.length ] = oToolbar ;
	}
	
	this.Redraw() ;
}

FCKToolbarSet.Redraw = function()
{
}

FCKToolbarSet.RefreshItemsState = function()
{
	
	for ( var i = 0 ; i < FCKToolbarSet.Toolbars.length ; i++ )
	{
		var oToolbar = FCKToolbarSet.Toolbars[i] ;
		for ( var j = 0 ; j < oToolbar.Items.length ; j++ )
		{
			oToolbar.Items[j].RefreshState() ;
		}
	}
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckdialog.js
 * 	Dialog windows operations.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:50
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKDialog = new Object() ;

// This method opens a dialog window using the standard dialog template.
FCKDialog.OpenDialog = function( dialogName, dialogTitle, dialogPage, width, height )
{
	// Setup the dialog info.
	var oDialogInfo = new Object() ;
	oDialogInfo.Title = dialogTitle ;
	oDialogInfo.Page = dialogPage ;
	oDialogInfo.Editor = window ;
	
	var sUrl = FCKConfig.BasePath + 'fckdialog.html' ;
	this.Show( oDialogInfo, dialogName, sUrl, width, height ) ;
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckdialog_gecko.js
 * 	Dialog windows operations. (Gecko specific implementations)
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:50
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

FCKDialog.Show = function( dialogInfo, dialogName, pageUrl, dialogWidth, dialogHeight )
{
	var iTop  = (screen.height - dialogHeight) / 2 ;
	var iLeft = (screen.width  - dialogWidth)  / 2 ;

	var sOption  = "location=no,menubar=no,resizable=no,toolbar=no,dependent=yes" +
		",width="  + dialogWidth +
		",height=" + dialogHeight +
		",top="  + iTop +
		",left=" + iLeft ;
	
	var oWindow = window.open( '', 'FCKEditorDialog', sOption, true ) ;
	oWindow.moveTo( iLeft, iTop ) ;
	oWindow.resizeTo( dialogWidth, dialogHeight ) ;
	oWindow.focus() ;
	oWindow.location.href = pageUrl ;
	
	oWindow.dialogArguments = dialogInfo ;
	
	this.Window = oWindow ;
	
	window.top.captureEvents( Event.CLICK | Event.MOUSEDOWN | Event.MOUSEUP | Event.FOCUS ) ;
	window.top.parent.addEventListener( 'mousedown', this.CheckFocus, true ) ;
	window.top.parent.addEventListener( 'mouseup', this.CheckFocus, true ) ;
	window.top.parent.addEventListener( 'click', this.CheckFocus, true ) ;
	window.top.parent.addEventListener( 'focus', this.CheckFocus, true ) ;		
}

FCKDialog.CheckFocus = function()
{
	if ( FCKDialog.Window && !FCKDialog.Window.closed )
	{
		FCKDialog.Window.focus() ;
		return false ;
	}
	else
	{
		window.top.releaseEvents(Event.CLICK | Event.MOUSEDOWN | Event.MOUSEUP | Event.FOCUS) ;
		window.top.parent.removeEventListener( 'onmousedown', FCKDialog.CheckFocus, true ) ;
		window.top.parent.removeEventListener( 'mouseup', FCKDialog.CheckFocus, true ) ;
		window.top.parent.removeEventListener( 'click', FCKDialog.CheckFocus, true ) ;
		window.top.parent.removeEventListener( 'onfocus', FCKDialog.CheckFocus, true ) ;
	}
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckcontextmenuitem.js
 * 	FCKContextMenuItem Class: represents a item in the context menu.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKContextMenuItem = function( contextMenu, commandName, label, hasIcon )
{
	this.ContextMenu	= contextMenu ;
	this.Command		= FCKCommands[ commandName ] ;
	this.Label			= label ? label : commandName ;
	this.HasIcon		= hasIcon ? true : false ;
}

FCKContextMenuItem.prototype.CreateTableRow = function( targetTable )
{
	// Creates the <TR> element.
	this._Row = targetTable.insertRow(-1) ;
	this._Row.className = 'CM_Disabled' ;
	this._Row.FCKContextMenuItem = this ;
	
	// Sets the mouse over event.
	this._Row.onmouseover = function()
	{
		if ( this.className != 'CM_Disabled' )
			this.className = 'CM_Over' ;
	}
	
	// Sets the mouse out event.
	this._Row.onmouseout = function()
	{
		if ( this.className != 'CM_Disabled' )
			this.className = 'CM_Option' ;
	}
	
	this._Row.onclick = function()
	{
		this.FCKContextMenuItem.ContextMenu.Hide() ;
		this.FCKContextMenuItem.Command.Execute() ;
		return false ;
	}
	
	var oCell = this._Row.insertCell(-1) ;
	oCell.className = 'CM_Icon' ;
	
	if ( this.HasIcon ) oCell.innerHTML = '<img alt="" src="' + FCKConfig.SkinPath + 'toolbar/button.' + this.Command.Name.toLowerCase() + FCKConfig.SkinType + '" width="' + FCKConfig.SkinSize + '" height="' + FCKConfig.SkinSize + '" unselectable="on">' ;
	
	oCell = this._Row.insertCell(-1) ;
	oCell.className		= 'CM_Label' ;
	oCell.unselectable	= 'on' ;
	oCell.noWrap		= true ;
	oCell.innerHTML		= this.Label ;
}

FCKContextMenuItem.prototype.SetVisible = function( isVisible )
{
	this._Row.style.display = isVisible ? '' : 'none' ;
}

FCKContextMenuItem.prototype.RefreshState = function()
{
	switch ( this.Command.GetState() )
	{
		case FCK_TRISTATE_ON :
		case FCK_TRISTATE_OFF :
			this._Row.className = 'CM_Option' ;
			break ;
		default :
			this._Row.className = 'CM_Disabled' ;
			break ;
	}
} 

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckcontextmenuseparator.js
 * 	FCKContextMenuSeparator Class: represents a separator in the toolbar.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKContextMenuSeparator = function()
{
}

FCKContextMenuSeparator.prototype.CreateTableRow = function( targetTable )
{
	// Creates the <TR> element.
	this._Row = targetTable.insertRow(-1) ;
	this._Row.className = 'CM_Separator' ;
	
	var oCell = this._Row.insertCell(-1) ;
	oCell.className = 'CM_Icon' ;
	
	oCell = this._Row.insertCell(-1) ;
	oCell.className = 'CM_Label' ;
	oCell.innerHTML = '<div></div>' ;
}

FCKContextMenuSeparator.prototype.SetVisible = function( isVisible )
{
	this._Row.style.display = isVisible ? '' : 'none' ;
}

FCKContextMenuSeparator.prototype.RefreshState = function()
{
	// Do nothing... its state doesn't change.
} 

/*
Sample output.
-----------------------------------------
<tr class="CM_Separator">
	<td class="CM_Icon"></td>
	<td class="CM_Label"><div></div></td>
</tr>
*//*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckcontextmenugroup.js
 * 	FCKContextMenuGroup Class: represents a group of items in the context 
 * 	menu. Generaly a group of items is directly dependent of the same rules.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:47
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKContextMenuGroup = function()
{
	this.IsVisible = true ;
	
	// Array with all available context menu items of this group.
	this.Items = new Array() ;
	
	// This OPTIONAL function checks if the group must be shown.
	this.ValidationFunction = null ;
}

// Adds an item to the group's items collecion.
FCKContextMenuGroup.prototype.Add = function( contextMenuItem )
{
	this.Items[ this.Items.length ] = contextMenuItem ;
}

// Creates the <TR> elements that represent the item in a table (usually the rendered context menu).
FCKContextMenuGroup.prototype.CreateTableRows = function( table )
{
	for ( var i = 0 ; i < this.Items.length ; i++ )
	{
		this.Items[i].CreateTableRow( table ) ;
	}
}

FCKContextMenuGroup.prototype.SetVisible = function( isVisible )
{
	for ( var i = 0 ; i < this.Items.length ; i++ )
	{
		this.Items[i].SetVisible( isVisible ) ;
	}
	
	this.IsVisible = isVisible ;
}

FCKContextMenuGroup.prototype.RefreshState = function()
{
	if ( ! this.IsVisible ) return ;
	
	for ( var i = 0 ; i < this.Items.length ; i++ )
	{
		this.Items[i].RefreshState() ;
	}
}/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckcontextmenu.js
 * 	Defines the FCKContextMenu object that is responsible for all 
 * 	Context Menu operations.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:49
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var FCKContextMenu = new Object() ;

// This property is internally used to indicate that the context menu has been created.
FCKContextMenu._IsLoaded = false ;

// This method creates the context menu inside a DIV tag. Take a look at the end of this file for a sample output.
FCKContextMenu.Reload = function()
{
	// Create the Main DIV that holds the Context Menu.
	this._Div = this._Document.createElement( 'DIV' ) ;
	this._Div.className			= 'CM_ContextMenu' ;
	this._Div.style.position	= 'absolute' ;
	this._Div.style.visibility	= 'hidden' ;
	this._Document.body.appendChild( this._Div );
	
	// Create the main table for the menu items.
	var oTable = this._Document.createElement( 'TABLE' ) ;
	oTable.cellSpacing = 0 ;
	oTable.cellPadding = 0 ;
	oTable.border = 0 ;
	this._Div.appendChild( oTable ) ;

	// Create arrays with all Items to add.
	
	this.Groups = new Object() ;
	
	// Generic items that are always available.
	this.Groups['Generic'] = new FCKContextMenuGroup() ;
	with ( this.Groups['Generic'] )
	{
		Add( new FCKContextMenuItem( this, 'Cut'	, FCKLang['Cut']	, true ) ) ;
		Add( new FCKContextMenuItem( this, 'Copy'	, FCKLang['Copy']	, true ) ) ;
		Add( new FCKContextMenuItem( this, 'Paste'	, FCKLang['Paste']	, true ) ) ;
	}
	
	// Link operations.
	this.Groups['Link'] = new FCKContextMenuGroup() ;
	with ( this.Groups['Link'] )
	{
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Link'	, FCKLang['EditLink']	, true ) ) ;
		Add( new FCKContextMenuItem( this, 'Unlink'	, FCKLang['RemoveLink']	, true ) ) ;
	}

	// Table Cell operations.	
	this.Groups['TableCell'] = new FCKContextMenuGroup() ;
	with ( this.Groups['TableCell'] )
	{
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["InsertRow"] ) ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["DeleteRows"] ) ) ;
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["InsertColumn"] ) ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["DeleteColumns"] ) ) ;
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["InsertCell"] ) ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["DeleteCells"] ) ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["MergeCells"] ) ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["SplitCell"] ) ) ;
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["CellProperties"] ) ) ;
		Add( new FCKContextMenuItem( this, 'TableProp', FCKLang["TableProperties"], true ) ) ;
	}

	// Table operations.	
	this.Groups['Table'] = new FCKContextMenuGroup() ;
	with ( this.Groups['Table'] )
	{
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Table', FCKLang["TableProperties"], true ) ) ;
	}
	
	// Image operations.
	this.Groups['Image'] = new FCKContextMenuGroup() ;
	with ( this.Groups['Image'] )
	{
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', FCKLang["ImageProperties"] ) ) ;
//		Add( new FCKContextMenuItem( this, 'Image', FCKLang["ImageProperties"], true ) ) ;
	}
	
	// Select field operations.
	this.Groups['Select'] = new FCKContextMenuGroup() ;
	with ( this.Groups['Select'] )
	{
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', "Selection Field Properties" ) ) ;
	}

	// Textarea operations.
	this.Groups['Textarea'] = new FCKContextMenuGroup() ;
	with ( this.Groups['Textarea'] )
	{
		Add( new FCKContextMenuSeparator() ) ;
		Add( new FCKContextMenuItem( this, 'Undefined', "Textarea Properties" ) ) ;
	}
	
	// Create all table rows (representing the items) in the context menu.
	for ( var o in this.Groups )
	{
		this.Groups[o].CreateTableRows( oTable ) ;
	}

	this._IsLoaded = true ;
}

FCKContextMenu.RefreshState = function()
{
  	// Get the actual selected tag (if any).
	var oTag = FCKSelection.GetSelectedElement() ;
	var sTagName ;
	
	if ( oTag )
	{
		sTagName = oTag.tagName.toUpperCase() ;
	}

	// Set items visibility.
	this.Groups['Link'].SetVisible( FCK.GetNamedCommandState( 'Unlink' ) != FCK_TRISTATE_DISABLED ) ;
	this.Groups['TableCell'].SetVisible( FCKSelection.HasAncestorNode('TD') ) ;		// TODO: Table Cell operations are not yet available.
	this.Groups['Table'].SetVisible( sTagName == 'TABLE' ) ;
	this.Groups['Image'].SetVisible( sTagName == 'IMG' ) ;
	this.Groups['Select'].SetVisible( sTagName == 'SELECT' ) ;
	this.Groups['Textarea'].SetVisible( sTagName == 'TEXTAREA' ) ;
	
	// Refresh the state of all visible items (active/disactive)	
	for ( var o in this.Groups )
	{
		this.Groups[o].RefreshState() ;
	}
}

/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckcontextmenu_gecko.js
 * 	Context Menu operations. (Gecko specific implementations)
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:49
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// The Context Menu CSS must be added to the parent document.
FCKTools.AppendStyleSheet( window.parent.document, FCKConfig.SkinPath + 'fck_contextmenu.css' ) ;

FCKContextMenu.Show = function( x, y )
{
	if ( ! this._Document )
	{
		this._Document = window.parent.document ;
	}

	// Create the context menu if needed.
	if ( !this._IsLoaded ) 
	{
		this.Reload() ;
		this._Div.style.zIndex = 10000 ;
		this._Div.oncontextmenu = function() { return false ; }
	}
	
	this.RefreshState() ;
	
	// The x and y parameters for Gecko are relative to the client
	var oFrames = [ FCK.EditorWindow.frameElement, window.frameElement ] ;
	for ( var i = 0 ; i < oFrames.length ; i++ )
	{
		var oParent = oFrames[i] ;
		while ( oParent )
		{
			x += oParent.offsetLeft ;
			y += oParent.offsetTop ;
			
			oParent = oParent.offsetParent ;
		}
	}

	// Verifies if the context menu is completely visible.
	var iXSpace = x + this._Div.offsetWidth - this._Div.ownerDocument.defaultView.innerWidth ;
	var iYSpace = y + this._Div.offsetHeight - this._Div.ownerDocument.defaultView.innerHeight ;
	
	if ( iXSpace > 0 ) x -= this._Div.offsetWidth ;
	if ( iYSpace > 0 ) y -= this._Div.offsetHeight ;
	
	// Set the context menu DIV in the specified location.
	this._Div.style.left	= x + 'px' ;
	this._Div.style.top		= y + 'px' ;

	// Watch the "OnClick" event for all windows to close the Context Menu.
	var oActualWindow = FCK.EditorWindow ;
	while ( oActualWindow )
	{
		oActualWindow.document.addEventListener( 'click', FCKContextMenu._OnDocumentClick, false ) ;
		if ( oActualWindow != oActualWindow.parent )
			oActualWindow = oActualWindow.parent ;
		else if ( oActualWindow.opener == null ) 
			oActualWindow = oActualWindow.opener ;
		else
			break ;
	}
	
	// Show it.
	this._Div.style.visibility	= '' ;
}

FCKContextMenu._OnDocumentClick = function( event )
{
	var e = event.target ;
	while ( e )
	{
		if ( e == FCKContextMenu._Div ) return ;
		e = e.parentNode ;
	}
	FCKContextMenu.Hide() ;
}

FCKContextMenu.Hide = function()
{
	this._Div.style.visibility = 'hidden' ;
	this._Div.style.left = this._Div.style.top = '1px' ;
}/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fck_last.js
 * 	These are the last script lines executed in the editor loading process.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:49
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// This is the last file loaded to complete the editor initialization and activation

// Activate pasting operations.
if ( FCKConfig.ForcePasteAsPlainText )
	FCK.Events.AttachEvent( "OnPaste", FCK.Paste ) ;

// Load the Toolbar
FCKToolbarSet.Name = FCKURLParams['Toolbar'] || 'Default' ;
FCKToolbarSet.Load( FCKToolbarSet.Name ) ;
FCKToolbarSet.Restart() ;

FCK.AttachToOnSelectionChange( FCKToolbarSet.RefreshItemsState ) ;

// Set some object references to the editor instance object (FCK).
FCK.Config		= FCKConfig ;
FCK.ToolbarSet	= FCKToolbarSet ;

FCK.SetStatus( FCK_STATUS_COMPLETE ) ;

// Call the special "FCKeditor_OnComplete" function that should be present in 
// the HTML page where the editor is located.
if ( typeof( window.parent.FCKeditor_OnComplete ) == 'function' )
	window.parent.FCKeditor_OnComplete( FCK ) ;
