/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * File Name: fckconfig.js
 * 	Editor configuration settings.
 * 
 * Version:  2.0 Beta 1
 * Modified: 2004-05-31 23:07:55
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// Custom Configurations (leave blank to ignore)
FCKConfig.CustomConfigurationsPath = '' ;	// '/fckeditor.config.js' ;

// Enables the debug window
FCKConfig.Debug = false ;

// Set the path for the skin files to use.
FCKConfig.SkinPath = FCKConfig.BasePath + 'skins/gnome/' ;
FCKConfig.SkinSize = '24' ;
FCKConfig.SkinType = '.png' ;

// Language settings
FCKConfig.AutoDetectLanguage = true ;
FCKConfig.DefaultLanguage    = "en" ;

// Enable XHTML support
FCKConfig.EnableXHTML		= false ;
FCKConfig.EnableSourceXHTML	= true ;

// Cut and Paste options
FCKConfig.ForcePasteAsPlainText	= false ;

// Link: Target Windows
FCKConfig.LinkShowTargets = true ;
FCKConfig.LinkTargets = '_blank;_parent;_self;_top' ;
FCKConfig.LinkDefaultTarget = '' ;

FCKConfig.ToolbarStartExpanded	= true ;
FCKConfig.ToolbarCanCollapse	= true ;


//##
//## Toolbar Buttons Sets
//##
FCKConfig.ToolbarSets = new Object() ;

FCKConfig.ToolbarSets["Default"] = [
	['Source', '-', 'Bold','Italic','Underline','StrikeThrough','-','Subscript','Superscript'],
	['OrderedList','UnorderedList','-','Outdent','Indent'],
	['JustifyLeft','JustifyCenter','JustifyRight','JustifyFull'],
	['Link','Unlink'/*,'Anchor'*/],
	['Image','Table','Rule'],
	['FontFormat','-','FontSize'],
] ;

FCKConfig.ToolbarSets["Svasta"] = [
	['Source','-','Save','NewPage','Preview'],
	['Cut','Copy','Paste'/*,'PasteText','PasteWord'*/,'-','Print'/*,'SpellCheck'*/],
	['Undo','Redo',/*'-','Find','Replace',*/'-','SelectAll','RemoveFormat'],
	['Bold','Italic','Underline','StrikeThrough','-','Subscript','Superscript'],
	['OrderedList','UnorderedList','-','Outdent','Indent'],
	['JustifyLeft','JustifyCenter','JustifyRight','JustifyFull'],
	['Link','Unlink'/*,'Anchor'*/],
	['Image','Table','Rule','SpecialChar'/*,'UniversalKey'*/,'Smiley'],
	/*['Form','Checkbox','Radio','Input','Textarea','Select','Button','ImageButton','Hidden']*/
	/*['ShowTableBorders','ShowDetails','-','Zoom'],*/
	[/*'FontStyleAdv','-','FontStyle','-',*/'FontFormat','-','FontName','-','FontSize'],
	/*['TextColor','BGColor'],*/
	['About']
] ;

FCKConfig.ToolbarSets["Basic"] = [
	['Bold','Italic','-','OrderedList','UnorderedList','-','Link','Unlink','-','About']
] ;

FCKConfig.ToolbarSets["Limited"] = [
	['Source','Save','NewPage'],
	['Cut','Copy','Paste'/*,'PasteText','PasteWord'*/,'-','Print'/*,'SpellCheck'*/],
	['Undo','Redo',/*'-','Find','Replace',*/'-','SelectAll','RemoveFormat'],
	['Bold','Italic','Underline','StrikeThrough','-','Subscript','Superscript'],
	['OrderedList','UnorderedList','-','Outdent','Indent'],
	['JustifyLeft','JustifyCenter','JustifyRight','JustifyFull'],
	['Link','Unlink'/*,'Anchor'*/],
	['Image','Table','Rule','SpecialChar'/*,'UniversalKey'*/,'Smiley'],
	/*['Form','Checkbox','Radio','Input','Textarea','Select','Button','ImageButton','Hidden']*/
	/*['ShowTableBorders','ShowDetails','-','Zoom'],*/
	['FontStyleAdv','-','FontStyle','-','FontFormat','-','FontName','-','FontSize'],
	/*['TextColor','BGColor'],*/
	['About']
] ;



// Font Names
FCKConfig.FontNames = 'Arial;Comic Sans MS;Courier New;Tahoma;Times New Roman;Verdana' ;

FCKConfig.Formats = '<P>;<H1>;<H2>';
FCKConfig.FormatsNames = 'Normal (P);Heading 1;Heading 2';

// Link Browsing
FCKConfig.LinkBrowser = false ;
FCKConfig.LinkBrowserURL = FCKConfig.BasePath + "filemanager/browser/default/browser.html?Connector=connectors/aspx/connector.aspx" ;
FCKConfig.LinkBrowserWindowWidth	= screen.width * 0.7 ;	// 70%
FCKConfig.LinkBrowserWindowHeight	= screen.height * 0.7 ;	// 70%

// Link Upload
FCKConfig.LinkUpload = true ;
FCKConfig.LinkUploadURL = FCKConfig.BasePath + "filemanager/upload/aspx/upload.aspx" ;
FCKConfig.LinkUploadWindowWidth	= 300 ;
FCKConfig.LinkUploadWindowHeight	= 150 ;
FCKConfig.LinkUploadAllowedExtensions	= "*" ;		// * or empty for all
FCKConfig.LinkUploadDeniedExtensions	= ".exe .asp .php .aspx .js .cfm .dll" ;	// empty for no one

//**
// Load the custom configurations file
if ( FCKConfig.CustomConfigurationsPath.length > 0 )
	FCKScriptLoader.AddScript( FCKConfig.CustomConfigurationsPath ) ;